/*->h.newx */


#define UISECT            0x7100
#define UDSECT            0x7101
#define UIPAGE            0x7102
#define UDPAGE            0x7103

#define UNDOGOMASTER      0x7104
#define UNDOQUITMASTER    0x7105

#define UNDOREGOMASTER    0x7106
#define UNDOREQUITMASTER  0x7107

#define UNFLUSHMS         0x7108
#define UNFLUSHMF         0x7109
#define UNFLUSHPS         0x710A
#define UNFLUSHPF         0x710B

#define UUFORCEMASTER     0x710C
#define URFORCEMASTER     0x710D

#define UUADDMASTER       0x710E
#define URADDMASTER       0x710F




typedef struct
{
 int dsection;
 int msection;
 int undo;

} newmapstr;



typedef struct
{
 int page;
 int section;

} newflowstr;




extern os_error * relinkpagerange(int page,int np,int section,filestr * file);
extern os_error * relinkpage(int page,int section,filestr * file);
extern os_error * renumbersections(filestr * file);

#define RENSECT  0x1
#define RENPLUS1 0x2
#define RENFLOW  0x4

extern os_error * renumberpages(int page,int section,int flags,filestr * file);








#define NEWMODELEFT  0
#define NEWMODERIGHT 1
#define NEWMODEBOTH  2

#define NEWLEFT      0
#define NEWRIGHT     1


typedef struct newstr
{
 sectiondatastr sectiondata;

 int            mode;            /* 0==left 1==right 2==both */
 int            columns[2];
 int            principleframe[2];
 int            topmargin[2];
 int            botmargin[2];
 int            leftmargin[2];
 int            rightmargin[2];
 int            headermargin[2];
 int            footermargin[2];
 columnstr      columndata[2];

 int            units;

	int            compatability;

 int            spare[3];
} newstr;






extern os_error * createnewdoc(newstr * xnew,filestr ** filep,char * name);

extern os_error * getnewdata(newstr * xnew,int section,filestr * file);

extern os_error * createpageboxes(objectloc * loc,newstr * xnew,int hand);



extern newstr         cnew;

extern newstr         defnewdata;



extern os_error * createsectionmap(int ndsection,int nmsection,int undo,
                                                              filestr * file);

extern os_error * updatesectionmap(int ndsection,int nmsection,int undo,
                                                              filestr * file);


