/*->c.fillstub */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"


#include "err.h"
#include "fsx.h"
#include "bf.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"
#include "xmath.h"
#include "avl.h"
#include "dbhi.h"
#include "deb.h"


#include "constants.h"
#include "str.h"
#include "object.h"
#include "xredraw.h"
#include "curve.h"


#include "viewr.h"
#include "view.h"


#include "filllink.h"

#include "fillstub.h"



static fillrenderfn    frfn;
static fillcopyfn      fcfn;
static filldeletefn    fdfn;
static filldswritefn   fsfn;




os_error * renderfill(viewredrawstr * v,curvestr * c,
                                      curvestylestr * cstyle,transformstr * t)

{
 if(cstyle->fill.fill && frfn) return(frfn(v,c,cstyle,t));
 else                          return(rendercurve(v,c,cstyle,t));
}


os_error * infofill(fillstr * fill,viewredrawstr * v,int * bits,int * pal)
{
 if(fill->fill) *bits=FILL_SHADEDCOLOUR;
 else           *bits=0;
 return(NULL);
 USE(pal);
 USE(v);
}



os_error * deletefill(fillstr * fill,filestr * file)
{
	//cprintf("del %d",fill->fill);
 if(fdfn) return(fdfn(fill,file));
 return(NULL);
}


os_error * copyfill(fillstr * d,fillstr * s,filestr * file)
{
	os_error * err=NULL;
//	cprintf("cp  s %d  d%d",s->fill,d->fill);
 if(fcfn) err=fcfn(d,file,s,file,0);
 else     d->fill=0;
//	cprintf("cp  s %d  d%d",s->fill,d->fill);
 return(err);
}


os_error * copyfillm(fillstr * d,filestr * dfile,
                     fillstr * s,filestr * sfile,int mode)
{
	os_error * err=NULL;
//	cprintf("cpm s %d d %d mode %d",s->fill,d->fill,mode);
 if(s->fill && fcfn) err=fcfn(d,dfile,s,sfile,mode);
 else                d->fill=0;
//	cprintf("cpm s %d d %d mode %d",s->fill,d->fill,mode);
 return(err);
}



os_error * dswritefill(fillstr * fill,buffer * bf,filestr * file)
{
 if(fsfn) return(fsfn(fill,bf,file));
 return(NULL);
}



static fillblockstr * fillblockroot=(fillblockstr*)(-1);


static int fbcmpcs(void * key1,void * key2)
{
 return(*((int*)key1)-*((int*)key2));
}


os_error * filllinkblock(fillblockstr * fillblock)
{
 avlsearch((int)fillblock,(int*)&fillblockroot,0,fbcmpcs);

 return(NULL);
}



fillblockstr * getfillroot(void)
{
 return(fillblockroot);
}


os_error * fillregister(fillrenderfn xfrfn,
                        fillcopyfn   xfcfn,
                        filldeletefn xfdfn,
                        filldswritefn xfsfn)
{
 frfn=xfrfn;
 fcfn=xfcfn;
 fdfn=xfdfn;
 fsfn=xfsfn;

 return(NULL);
}



