/*->h.dbstyle */

extern void setrulewidth(int fp);
extern int  getrulewidth(int fp);

extern void openstylebox(int fp);

extern int  getfontsize(int fp);
extern void setfontsize(int fp);
extern int  getcase(int fp);
extern void setcase(int fp);
extern int  getalign(int fp);
extern void setalign(int fp);

extern int  getnexteffect(int fp);
extern void geteffectname(int fp);
extern void cleareffect(int fp);

extern int  geteffx(int fp);
extern void seteffx(int fp);
extern int  getscope(int fp);
extern void setscope(int fp);
extern int  getbaseshift(int fp);
extern void setbaseshift(int fp);

extern int  getparalevel(int fp);
extern void setparalevel(int fp);

extern int  getsmallcaps(int fp);
extern void setsmallcaps(int fp);


extern int  getstylescope(int fp);

extern int  islocaleffect(int fp);

extern void caretcontext(int fp);

extern void opentextfont(int fp);

extern int styleindex(userstylebasestr * stylebase,int rank);


extern os_error * txsetalign(int xalign,viewstr * view);
extern os_error * txseteffx(int bits,viewstr * view);
extern os_error * txopenfontmenu(viewstr * view);
extern os_error * txsetfontsize(int newsize,viewstr * view);

extern void opentextstyle(int fp);
extern void opentextcolour(int fp);
extern void opentextformat(int fp);
extern void opentexttabs(int fp);
extern void opentextrules(int fp);

extern void readleading(int fp);
extern void writeleading(int fp);

extern os_error * opentextstylebox(filestr * file,viewstr * view);


typedef os_error * (*setuserstylemenuhandler)(int n);
typedef os_error * (*getuserstylemenuhandler)(int * n);

extern  os_error * openuserstylemenu(setuserstylemenuhandler xssmh,
                                     getuserstylemenuhandler xgsmh,int handle);



extern int  timestring(int fp);
extern int  xdatestring(int fp);

extern int  getuserstyle(int fp);

extern void setuserstyle(int fp);
extern int  isuserstyle(int fp);


extern os_error * markindex(void);
extern os_error * markcontents(void);
extern os_error * applypara(vector * s);



#define FMAPSUB     1
#define FMAPREPLACE 0

extern os_error * fmapbox(filestr * file,int * result,int n,int first);




extern os_error * dbstyleinit(void);



