/*->h.deb */

typedef void (*debfn)(void);   


#ifdef _DEBUG

#define dprintf xdprintf
#define cprintf xcprintf
#define cprintfw xcprintfw

#else

extern int zcprintf(char * format, ...);
extern int zdprintf(int line,char * format, ...);
extern int zcprintfw(wchar_t * format, ...);

#define dprintf 1 || zdprintf
#define cprintf 1 || zcprintf
#define cprintfw 1 || zcprintfw


#endif


extern void xdprintf(int line,char * format, ...);
extern void xcprintf(char * format, ...);
extern void xcprintfw(wchar_t * format, ...);


//extern void debugenable(debfn xdeb);
extern int  debugactive(void);
extern int  debugactive2(void);

extern void lprintf(char * format, ...);
extern void lerror(char * v,os_error * err);

