#include <stdafx.h>

#include <stdlib.h>
#include <string.h>


#include "shlobj.h"
#include "objbase.h"



#include "os.h"
#include "etc.h"
#include "deb.h"
#include "wimp.h"
#include "wos.h"
#include "poll.h"


#include "osshell.h"




static int CALLBACK browsecallback(HWND hwnd,UINT uMsg,LPARAM lp, LPARAM pData)
{

 switch(uMsg) 
 {
  case BFFM_INITIALIZED:
                        SendMessage(hwnd,BFFM_SETSELECTION,TRUE,(LPARAM)pData);
                        break;
 }
 return 0;
}





os_error * osshellbrowseforfolder(char * path,char * title,wimp_w parent,int flags)
{
 LPITEMIDLIST  idlist;
 BROWSEINFO    bi;
// IShellFolder *psf;

/* 
 DWORD dwAttribs = SFGAO_FOLDER;
 LPITEMIDLIST  pidl;
 wchar_t xname[MAX_PATH];

 MultiByteToWideChar(CP_ACP,0,path,strlen(path)+1,xname,MAX_PATH);

 SHGetDesktopFolder(&psf);
 
 psf->ParseDisplayName(NULL,NULL,xname,NULL,&pidl,&dwAttribs);

 nb see below for release

*/


 bi.hwndOwner=(HWND)parent; 
// bi.pidlRoot=pidl; 
 bi.pidlRoot=NULL;
 bi.pszDisplayName=(LPTSTR)path; 
 bi.lpszTitle=(LPTSTR)title; 
 bi.ulFlags=0; 
 bi.lpfn=browsecallback; 
 bi.lParam=(LPARAM)path; 
 bi.iImage=0; 


 idlist=SHBrowseForFolder(&bi);
 if(idlist)
 {
  LPMALLOC pMalloc;

  SHGetPathFromIDList(idlist,(LPSTR)path);

  SHGetMalloc(&pMalloc);

  pMalloc->Free(idlist);

  pMalloc->Release();
 }

// psf->Release();

 return(NULL);

 USE(flags);
}








os_error * osshellshortcuttarget(char * link,char * path,int size)
{
	HRESULT      hres;
	IShellLink * psl;


	*path=0;

	//Create the ShellLink object
	hres=CoCreateInstance(CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,IID_IShellLink,(LPVOID*)&psl);

	if(SUCCEEDED(hres))
	{
		IPersistFile* ppf;

		//Bind the ShellLink object to the Persistent File

		hres=psl->QueryInterface(IID_IPersistFile,(LPVOID*)&ppf);
		if(SUCCEEDED(hres))
		{
			WORD wsz[MAX_PATH];

			//Get a UNICODE wide string wsz from the Link path
			MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,link,-1,wsz,MAX_PATH);

			//Read the link into the persistent file

			hres=ppf->Load(wsz,0);

			if(SUCCEEDED(hres))
			{
				//Read the target information from the link object
				//UNC paths are supported (SLGP_UNCPRIORITY)

				psl->GetPath(path,size,NULL,SLGP_UNCPRIORITY);

				//Read the arguments from the link object
    //				psl->GetArguments(Temp.GetBuffer(1024), 1024);
			}
		}
	}

	psl->Release();
	//Return the Target and the Argument as a CString

	return(NULL);
}










os_error * osshellinit(int mode)
{

	if(mode & OSSHELLOLE)
	{
		OleInitialize(NULL);
	}
	else
	{
  CoInitialize(NULL);
	}

 return(NULL);
}



os_error * osshellfinit(int mode)
{

 if(mode & OSSHELLOLE)
 {
 	OleUninitialize();
 }
 else
 {
  CoUninitialize();
 }

 return(NULL);
}



#ifdef NEVER

os_error * shellgetappdata(HWND hwnd,char * path,int size)
{
 os_error * err=NULL;
 LPITEMIDLIST pidlRoot = NULL;
 LPMALLOC pMalloc = NULL;

 SHGetMalloc(&pMalloc);

 SHGetSpecialFolderLocation(hwnd,CSIDL_APPDATA,&pidlRoot);
 SHGetPathFromIDList(pidlRoot,path);

 cprintf("app data %s",path);

 if(pidlRoot)
 {
  pMalloc->Free(pidlRoot);
 }

 pMalloc->Release();

 return(err);
 USE(size);
}

#endif


