/*->h.rulers */

extern os_error * refreshrulers(viewstr * view);
extern os_error * closerulers(viewstr * view);
extern os_error * setextentrulers(viewstr * view);
extern os_error * createrulers(viewstr * view);
extern os_error * openvruler(viewstr * view,wimp_openstr * o);
extern os_error * openhruler(viewstr * view,wimp_openstr * o);
extern os_error * openrulerpatch(viewstr * view,wimp_openstr * o);

extern int  getrulers(int fp);
extern void setrulers(int fp);
extern void xsetrulers(int open,viewstr * view);
extern void togglerulers(viewstr * view);


#define MAXZONE      3
#define PATTERNSCALE 8

extern int    hsteps[MAXZONE][3];
extern int    hbsteps[MAXZONE][3];
extern int    ubsteps[MAXZONE][3];
extern char * hpattern[MAXZONE][3];

extern int        mzone(viewstr * view);
extern void       rulerprint(int n,int x,int y,int justify);
extern os_error * rulerfontstart(void);
extern void       rulerfontend(void);



typedef struct rmstr
{
 int x[2];
 int y[2];

 int ax[2];
 int ay[2];

} rmstr;


extern os_error * rulermarkupdate(rmstr * xnew);
extern os_error * rulermarkstart(rmstr * xnew,int page,int branch,
                                                         filestr * file);
extern os_error * rulermarkend(void);


extern os_error * rulersave(filestr * file);
extern os_error * rulerload(filestr * file);


