/*->h.dbtabs */

typedef struct dbtabstr
{
 int  left;             /* indent posn/-1 for none */
 int  right;
 int  first;

 int  lrule;            /* rule pos/-1 for none */
 int  rrule;

 int  oldtab;           /* tab ruler key */
 int  newtab;           /* tab ruler key */

 int  apply;            /* apply ruler - on entry <0 no, >=0 yes */

 char leader[4];

 int  lock;             /* body text - prevent indents being removed */

 int  parawidth;
 int  parax;
 int  paray;

} dbtabstr;


#define TBFOK    0
#define TBFAPPLY 1



typedef os_error * (*dtbfn)(dbtabstr* dtb,int code);

extern os_error * opentabs(dbtabstr * dtb,dtbfn dtbf,dboxstr * parent,viewstr * view,filestr * file);

