#include "stdafx.h"

#include "resource.h"

#include "os.h"
#include "transform.h"
#include "xprocess.h"
#include "sprite.h"
#include "wimp.h"

#include "wos.h"

#include "poll.h"
#include "pane.h"
#include "temp.h"
#include "trans.h"
#include "deb.h"

#include "etc.h"


static wimp_w infohandle;



static os_error * infoicon(wimp_w handle,uservalue userhandle,wimp_mousestr * m);
static os_error * infokey(wimp_w handle,uservalue userhandle,int icon,int * key);

static os_error * infoclose(wimp_w w,uservalue userhandle)
{
 os_error * err;


 remclickevent(infoicon,infohandle,0);
 remcloseevent(infoclose,infohandle,0);
 remkeyevent(infokey,infohandle,0);
 remhelpevent(NULL,infohandle,TINFO);

 err=closedown(&infohandle);

 return(err);

 USE(userhandle);
 USE(w);
}


static os_error * infokey(wimp_w handle,uservalue userhandle,int icon,int * key)
{
 os_error * err;

 err=NULL;
 
 if(*key==27)
 {
  err=infoclose(handle,userhandle);
  *key=-1;
 }

 return(err);

 USE(icon);
}



static os_error * infoicon(wimp_w handle,uservalue userhandle,wimp_mousestr * m)
{
 os_error * err;
 TCHAR      v[256];

 err=NULL;

 switch(m->i)
 {
               case IDOK:
                         err=infoclose(handle,userhandle);
                         break;

       case IDC_INFO_WEB:
                         tsprintf(sizeof(v)/sizeof(TCHAR),v,TEXT("{WEB}"));
                         ShellExecute((HWND)handle,TEXT("open"),v,NULL,NULL,0); 
                         break;

     case IDC_INFO_EMAIL:
                         tsprintf(sizeof(v)/sizeof(TCHAR),v,TEXT("mailto:{EMAIL}"));
                         ShellExecute((HWND)handle,TEXT("open"),v,NULL,NULL,0);
                         break;

  case IDC_INFO_HOMEPAGE:
                         tsprintf(sizeof(v)/sizeof(TCHAR),v,TEXT("{HOME}"));
                         ShellExecute((HWND)handle,TEXT("open"),v,NULL,NULL,0);
                         break;
 }

 return(err);
}










os_error * infowindow2(wimp_w parent,int version,TCHAR * datestring,TCHAR * nameplus)
{
 os_error * err;

 if(infohandle) err=forward(infohandle,0,NULL);
 else
 {
  err=createwindowtitleparent(TINFO,TEXT("{ABOUT}"),&infohandle,parent);

  if(!err)
  {
   writeiconf(infohandle,IDC_INFO_VERSION,"%d.%02d %s",version/100,version % 100,datestring);
   if(nameplus)	writeiconf(infohandle,IDC_INFO_NAME,nameplus);
   else         writeiconf(infohandle,IDC_INFO_NAME,TEXT("{NAME}"));
   writeiconf(infohandle,IDC_INFO_COPYRIGHT,TEXT("{COPY}"));
   writeiconf(infohandle,IDC_INFO_AUTHOR,TEXT("{AUTHOR}"));

   addclickevent(infoicon,infohandle,0);
   addcloseevent(infoclose,infohandle,0);
   addkeyevent(infokey,infohandle,0);
   addhelpevent(NULL,infohandle,TINFO);

   popup(infohandle,0);

   iecarrot(infohandle,IDOK);
  }
 }

 return(err);
}


os_error * infowindow(wimp_w parent,int version,TCHAR * datestring)
{
	return(infowindow2(parent,version,datestring,NULL));
}


static templates temptable[]=
{
 TINFO,1,0,TEXT("Info"),

 TLAST,  0,0,TEXT("")
};


static templink templatelink;






os_error * infowindowinit(void)
{
 return(addtemplates(NULL,NULL,temptable,&templatelink));
}

